<?php

namespace Litecms\Coupan;

use User;

class Coupan
{
    /**
     * $coupan object.
     */
    protected $coupan;

    /**
     * Constructor.
     */
    public function __construct(\Litecms\Coupan\Interfaces\CoupanRepositoryInterface $coupan)
    {
        $this->coupan = $coupan;
    }

    /**
     * Returns count of coupan.
     *
     * @param array $filter
     *
     * @return int
     */
    public function count()
    {
        return  0;
    }

    /**
     * Make gadget View
     *
     * @param string $view
     *
     * @param int $count
     *
     * @return View
     */
    public function gadget($view = 'admin.coupan.gadget', $count = 10)
    {

        if (User::hasRole('user')) {
            $this->coupan->pushCriteria(new \Litepie\Litecms\Repositories\Criteria\CoupanUserCriteria());
        }

        $coupan = $this->coupan->scopeQuery(function ($query) use ($count) {
            return $query->orderBy('id', 'DESC')->take($count);
        })->all();

        return view('coupan::' . $view, compact('coupan'))->render();
    }
}
