<?php

namespace Litecms\Coupan\Repositories\Presenter;

use League\Fractal\TransformerAbstract;
use Hashids;

class CoupanTransformer extends TransformerAbstract
{
    public function transform(\Litecms\Coupan\Models\Coupan $coupan)
    {
        return [
            'id'                => $coupan->getRouteKey(),
            'key'               => [
                'public'    => $coupan->getPublicKey(),
                'route'     => $coupan->getRouteKey(),
            ], 
            'offered_by'        => $coupan->offered_by,
            'coupan_type'       => $coupan->coupan_type,
            'coupan_code'       => $coupan->coupan_code,
            'description'       => $coupan->description,
            'status'            => $coupan->status,
            'amount'            => $coupan->amount,
            'is_amt_pct'        => $coupan->is_amt_pct,
            'min_order_amt'     => $coupan->min_order_amt,
            'seller_ids'        => $coupan->seller_ids,
            'user_ids'          => $coupan->user_ids,
            'product_ids'       => $coupan->product_ids,
            'start_time'        => $coupan->start_time,
            'end_time'          => $coupan->end_time,
            'max_redem_count'   => $coupan->max_redem_count,
            'max_redem_amount'  => $coupan->max_redem_amount,
            'redem_count'       => $coupan->redem_count,
            'redem_amount'      => $coupan->redem_amount,
            'url'               => [
                'public'    => trans_url('coupan/'.$coupan->getPublicKey()),
                'user'      => guard_url('coupan/coupan/'.$coupan->getRouteKey()),
            ], 
            'status'            => trans('app.'.$coupan->status),
            'created_at'        => format_date($coupan->created_at),
            'updated_at'        => format_date($coupan->updated_at),
        ];
    }
}